program Wahrheitstabelle (input, output);
{ Erstellt eine Wahrheitstafel.
  Eingaben: Anzahl der Aussagen, und wie sie behandelt werden sollen
  Ausgabe: Wahrheitstafel aktualisiert sich dann und wird neu ausgegeben.}

  Uses Math, sysutils;

  const
  MAXSPALTEN = 10;
  SPALTBREITE = 4;
  MAXSZEILEN = 1024;
  BUCHSTABEN='ABCDEFGHIJ';

  type
  tZIndex = 1..MAXSZEILEN;
  tSIndex = 1..MAXSPALTEN;
  tMatrix = array[tZIndex, tSIndex] of boolean;
  tSBoolean = array[tSIndex] of boolean;
  tText = array[tSIndex] of string;

  var
  EntstandenAus: tText;
  Matrix: tMatrix;
  AktiveSpalten: tSBoolean;
  iEingabe, iSpalte1, iSpalte2, iZiel, AktiveZeilen, i, j: integer;
  cEingabe, cSpalte1, cSpalte2, cZiel : char;
  
  
  function MatrixErzeugen(var iEingabe: integer): tMatrix;
 
    var
    WahrFalsch : boolean;
    zeile, spalte, k : integer;
 
  begin
    for i := 1 to AktiveZeilen do
       for j := 1 to iEingabe do
       begin
       
         WahrFalsch:=false;
         zeile := (AktiveZeilen-i);
         spalte := (iEingabe-j+1);
         
         for k := 1 to Spalte do
         begin
          
           if Zeile mod 2 = 0 then
             WahrFalsch := false
           else
             WahrFalsch := true;
           Zeile := Zeile div 2;
         end;
         MatrixErzeugen[i][j] := WahrFalsch
       end
  end;
  
  procedure Ausgabe();
  begin
  { Ausgabe im Monitor}
    writeln();
    writeln('Aussagen:');
    write('Nr':SPALTBREITE);
    write('|':SPALTBREITE);
    write('A|':SPALTBREITE);
    write('B|':SPALTBREITE);
    write('C|':SPALTBREITE);
    write('D|':SPALTBREITE);
    write('E|':SPALTBREITE);
    write('F|':SPALTBREITE);
    write('G|':SPALTBREITE);
    write('H|':SPALTBREITE);
    write('I|':SPALTBREITE);
    writeln('J|':SPALTBREITE);
    write(' ':SPALTBREITE);
    write('|':SPALTBREITE);
    for j := 1 to MAXSPALTEN do  write(EntstandenAus[j]+'|':SPALTBREITE);
    writeln();
    for j := 0 to MAXSPALTEN +1 do
    for i := 1 to SPALTBREITE  do  write('_');
    writeln();
    
    for i := 1 to AktiveZeilen do
    begin
      for j := 0 to MAXSPALTEN do
        if j = 0 then
        begin
          write(i:SPALTBREITE);
          write('|':SPALTBREITE)
        end  
        else
          if AktiveSpalten[j] then
            if Matrix[i][j] then
              write('w|':SPALTBREITE)
            else 
              write('f|':SPALTBREITE)
          else
            write('|':SPALTBREITE);
        writeln()
    end;
    writeln('');
    writeln(' Aktion wählen:          x(<ctrl> + z/c zum Beenden.)');
    writeln('__________________');
    writeln('K = Konjunktion  ∧');
    writeln('D = Disjunktion  ∨');
    writeln('I = Implikation  ⇒');
    writeln('A = Aequivalen   ⇔');
    writeln('N = Negation     ¬');
    writeln('L = Löschen');
    writeln('')
  end;
  
  procedure Konjunktion(var A, B, Ziel: integer);
  begin
      AktiveSpalten[Ziel]:=true;
      EntstandenAus[Ziel]:= BUCHSTABEN[A]+'∧'+BUCHSTABEN[B];
      
    for i := 1 to AktiveZeilen do
      if Matrix[i][A] and  Matrix[i][B] then
        Matrix[i][Ziel]:= true
  end;
  
  procedure Disjunktion(var A, B, Ziel: integer);
  begin
    AktiveSpalten[Ziel]:=true;
    EntstandenAus[Ziel]:= BUCHSTABEN[A]+'∨'+BUCHSTABEN[B];
    for i := 1 to AktiveZeilen do
      if Matrix[i][A] or  Matrix[i][B] then
        Matrix[i][Ziel]:= true;
  end;
  
  procedure Implikation(var A, B, Ziel: integer);
  begin
    AktiveSpalten[Ziel]:=true;
    EntstandenAus[Ziel]:= BUCHSTABEN[A]+'⇒'+BUCHSTABEN[B];
    for i := 1 to AktiveZeilen do
      if Matrix[i][A] then
        Matrix[i][Ziel]:= Matrix[i][B]
      else
        Matrix[i][Ziel]:= true
  end;
  
  procedure Aequivalenz(var A, B, Ziel: integer);
  begin
  AktiveSpalten[Ziel]:=true;
  EntstandenAus[Ziel]:= BUCHSTABEN[A]+'⇔'+BUCHSTABEN[B];
    for i := 1 to AktiveZeilen do
      if Matrix[i][A] = Matrix[i][B] then
        Matrix[i][Ziel]:= true;
  end;
  
  procedure Negation(var A: integer);
  begin
  EntstandenAus[A]:= ' ¬'+BUCHSTABEN[A];
    for i := 1 to AktiveZeilen do
      if Matrix[i][A] = true then
        Matrix[i][A]:= false
        else
        Matrix[i][A]:= true
  end;
  
  procedure Loeschen(var A: integer);
  begin
    AktiveSpalten[A]:=false;
    EntstandenAus[A]:=('');
    for i := 1 to AktiveZeilen do
        Matrix[i][A]:= false
  end;
  
begin
{ Mit diesem kleinem Programm kann man Wahr-Falsch-Aussagen in einer 
* Wahrheitstafel untersuchen. Zeile "EntstandeAus" inizialesieren}

  for j := 1  to MAXSPALTEN do
    EntstandenAus[j]:=''; {Initialisierung}
    
  writeln('Wie viele Aussagen sollen untersucht werden?');
  write('Geben Sie eine nartuerliche ganze Zahle zwischen 2 und 10 ein:');
  readln(iEingabe);
  
  { Waechter}
  if (iEingabe < 2) or (iEingabe > 10) then
    write('ungültige eingabe.')
  else
  begin
  
    for j := 1 to iEingabe do
      AktiveSpalten[j] := true;
     
    AktiveZeilen := iEingabe;
    
    AktiveZeilen := 2 ** iEingabe; {Potenzmenge} 
     
    Matrix := MatrixErzeugen(iEingabe);
   
    Ausgabe();
    
    while not eof do {Schleife Benutzer Dialog}
    begin
      readln(cEingabe);
      writeln('Spalte wählen von A bis J');
      readln(cSpalte1);
      if (UpperCase(cEingabe)<>'N') then
       if (UpperCase(cEingabe)<>'L') then
        begin
          writeln('Zweite der Spalte wählen von A bis J');
          readln(cSpalte2);
          writeln('Zielspalte wählen von A bis J');
          readln(cZiel);
        end;
    
      { Datenkupplung von chr to integer}
      iSpalte1 := Pos(UpperCase(cSpalte1), BUCHSTABEN);
      iSpalte2 := Pos(UpperCase(cSpalte2), BUCHSTABEN);
      iZiel := Pos(UpperCase(cZiel), BUCHSTABEN);
     
      case UpperCase(cEingabe) of
      'K': Konjunktion(iSpalte1, iSpalte2, iZiel);
      'D': Disjunktion(iSpalte1, iSpalte2, iZiel);
      'I': Implikation(iSpalte1, iSpalte2, iZiel);
      'A': Aequivalenz(iSpalte1, iSpalte2, iZiel);
      'N': Negation(iSpalte1);
      'L': Loeschen(iSpalte1)
      end;
      Ausgabe();
    end {SchleifeEnde Benutzer Dialog}
  end
end.
